/***********************************************
 * orginal plugin (AntiAfk) by Voogru <voogru@voogru.com>
 * modified by Andy <andy@resourcecode.de>
 *
 * (Stripped old unstuck/code and added 
 * Anti-ReadyRoom camping routine)
 *
 * "Do whatever you want with it"
 ***********************************************/

#include <extdll.h>			// always
#include <meta_api.h>		// of course
#include <dllapi.h>
#include "sdk_util.h"		// UTIL_LogPrintf, etc
#include <h_export.h>
#include "plugin.h"
#include "cbase.h"

char msg[1024];
playerinfo_t	PlayerInfo[1024];

cvar_t nsa_max_idletime			= {"nsa_max_idletime",		"180",	FCVAR_ARCHIVE};
cvar_t nsa_max_rrcamptime		= {"nsa_max_rrcamptime",	"90",	FCVAR_ARCHIVE};
cvar_t nsa_check_angles			= {"nsa_check_angles",		"0",	FCVAR_ARCHIVE};
cvar_t nsa_disable_notice		= {"nsa_disable_notice",	"0",	FCVAR_ARCHIVE};

enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;

int DispatchSpawn(edict_t *pEntity) 
{
	PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime = 0;
	PlayerInfo[ENTINDEX(pEntity)].Idle.NextIdleCheck = 0;
	PlayerInfo[ENTINDEX(pEntity)].Idle.OldOrigin = 0;

	RETURN_META_VALUE(MRES_HANDLED, 0);
}

BOOL ClientConnect(edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[128])
{
	//Reset these to 0 in ClientConnect, and ClientPutInServer, and ClientDisconnect so were sure they dont fuck up.
	PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime = 0;
	PlayerInfo[ENTINDEX(pEntity)].Idle.NextIdleCheck = 0;
	PlayerInfo[ENTINDEX(pEntity)].Idle.OldOrigin = 0;
	PlayerInfo[ENTINDEX(pEntity)].InGame = false;//There not in the game just yet.
	RETURN_META_VALUE(MRES_HANDLED,TRUE);	
}

void ClientPutInServer(edict_t *pEntity)
{
	//Reset all the values
	PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime = 0;
	PlayerInfo[ENTINDEX(pEntity)].Idle.NextIdleCheck = 0;
	PlayerInfo[ENTINDEX(pEntity)].Idle.OldOrigin = 0;
	RETURN_META(MRES_HANDLED);
}

void ClientDisconnect(edict_t *pEntity)
{
	//Reset all the values when they disconnect.
	PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime = 0;
	PlayerInfo[ENTINDEX(pEntity)].Idle.NextIdleCheck = 0;
	PlayerInfo[ENTINDEX(pEntity)].Idle.OldOrigin = 0;
	PlayerInfo[ENTINDEX(pEntity)].InGame = false;
	RETURN_META(MRES_HANDLED);
}

void PlayerPreThink(edict_t *pEntity)
{
	if(!PlayerInfo[ENTINDEX(pEntity)].InGame)
		PlayerInfo[ENTINDEX(pEntity)].InGame = true;//Now there in the game.

	//RR-Warning
	//pEntity->v.playerclass 1 == ReadyRoom
	if(CVAR_GET_FLOAT("nsa_max_rrcamptime") > 0)
	{
		if(pEntity->v.playerclass == 1 && PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime == CVAR_GET_FLOAT("nsa_max_rrcamptime")-20 && !IsAdmin(pEntity))//Ignore server ops
		{
			sprintf(msg, "* WARNING! Please join a team. If you refuse, you will be kicked in 20 seconds!\n");
			ClientPrint2(pEntity, HUD_PRINTTALK, msg);
			PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime++;
		}

		if(pEntity->v.playerclass == 1 && PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime >= CVAR_GET_FLOAT("nsa_max_rrcamptime") && !IsAdmin(pEntity))
		{
			PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime = 0;
			
			sprintf(msg, "* %s has been kicked due to ReadyRoom camping.\n", STRING(pEntity->v.netname));
			NSASayAll(msg, HUD_PRINTTALK);	
			
			CLIENT_PRINTF(pEntity, print_console, "You are being kicked due to ReadyRoom camping.\n");
			CLIENT_COMMAND(pEntity, "disconnect\n");
		}
	}

	if(CVAR_GET_FLOAT("nsa_max_idletime") > 0)
	{
		//AFK-Warning
		if(PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime == CVAR_GET_FLOAT("nsa_max_idletime")-15 && !IsAdmin(pEntity))//Ignore server ops
		{
			sprintf(msg, "* WARNING! You appear to be idling and you'll be kicked within 15 seconds if you do not move!\n");
			ClientPrint2(pEntity, HUD_PRINTTALK, msg);	
			PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime++;
		}

		// RR-Camper
		//pEntity->v.playerclass 1 == ReadyRoom

		// AFK
		if(PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime >= CVAR_GET_FLOAT("nsa_max_idletime") && !IsAdmin(pEntity))
		{
			PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime = 0;
			
			sprintf(msg, "* %s has been kicked because he appears to be idling.\n", STRING(pEntity->v.netname));
			NSASayAll(msg, HUD_PRINTTALK);	
			
			CLIENT_PRINTF(pEntity, print_console, "You have been disconnected from the server because you appeared to be idle.\n");
			CLIENT_COMMAND(pEntity, "disconnect\n");
		}
	}

	RETURN_META(MRES_HANDLED);
}

void PlayerPostThink(edict_t *pEntity)
{
	if(PlayerInfo[ENTINDEX(pEntity)].InGame 
		&& PlayerInfo[ENTINDEX(pEntity)].Idle.NextIdleCheck < gpGlobals->time 
		&& GetPlayerClass(pEntity) != 10 //Make sure he aint no commander
		&& GetPlayerClass(pEntity) != 6 //Make sure he aint evolving (it takes time to evolve)
		&& pEntity->v.playerclass != 5 ) // Make sure he aint no observer 
	{
		int CurrentOrigin = 0;
		if(CVAR_GET_FLOAT("nsa_check_angles")) {
			CurrentOrigin = pEntity->v.origin.x + pEntity->v.origin.y + pEntity->v.origin.z + pEntity->v.v_angle.x + pEntity->v.v_angle.y + pEntity->v.v_angle.z;
		} else {
			CurrentOrigin = pEntity->v.origin.x + pEntity->v.origin.y + pEntity->v.origin.z;
		}

		if((pEntity->v.playerclass == 1 && CVAR_GET_FLOAT("nsa_max_rrcamptime") > 0 ) || ( PlayerInfo[ENTINDEX(pEntity)].Idle.OldOrigin == CurrentOrigin && CVAR_GET_FLOAT("nsa_max_idletime") > 0 ) ) // Same Position or ReadyRoom Camper?
		{
			PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime += 1;
		}
		else
			PlayerInfo[ENTINDEX(pEntity)].Idle.IdleTime = 0;
		
		if(CVAR_GET_FLOAT("nsa_check_angles")){
			PlayerInfo[ENTINDEX(pEntity)].Idle.OldOrigin = pEntity->v.origin.x + pEntity->v.origin.y + pEntity->v.origin.z + pEntity->v.v_angle.x + pEntity->v.v_angle.y + pEntity->v.v_angle.z;
		} else {
			PlayerInfo[ENTINDEX(pEntity)].Idle.OldOrigin = pEntity->v.origin.x + pEntity->v.origin.y + pEntity->v.origin.z;
		}
		PlayerInfo[ENTINDEX(pEntity)].Idle.NextIdleCheck = gpGlobals->time + 1.0;

	}
	RETURN_META(MRES_HANDLED);
}



// Must provide at least one of these..
static META_FUNCTIONS gMetaFunctionTable = {
	NULL,			// pfnGetEntityAPI				HL SDK; called before game DLL
	NULL,			// pfnGetEntityAPI_Post			META; called after game DLL
	GetEntityAPI2,	// pfnGetEntityAPI2				HL SDK2; called before game DLL
	NULL,			// pfnGetEntityAPI2_Post		META; called after game DLL
	NULL,			// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
	NULL,			// pfnGetNewDLLFunctions_Post	META; called after game DLL
	NULL,			// pfnGetEngineFunctions		META; called before HL engine
	NULL,			// pfnGetEngineFunctions_Post	META; called after HL engine
};

// Description of plugin
plugin_info_t Plugin_info = {
   META_INTERFACE_VERSION,               // interface version
   "AFK-Kick",						 // name
   "2.0c",                            // version
   "9/7/2003",							 // date
   "Andy ( modified AntiAfk by voogru <voogru@voogru.com> )",		 // author
   "",			 // url
   "AFKKICK",							 // logtag
   PT_ANYTIME,						 // (when) loadable
   PT_ANYTIME,                       // (when) unloadable
};


// Global vars from metamod:
meta_globals_t *gpMetaGlobals;		// metamod globals
gamedll_funcs_t *gpGamedllFuncs;	// gameDLL function tables
mutil_funcs_t *gpMetaUtilFuncs;		// metamod utility functions

C_DLLEXPORT int Meta_Query(char *ifvers, plugin_info_t **pPlugInfo,	mutil_funcs_t *pMetaUtilFuncs) {
	*pPlugInfo=&Plugin_info;
	gpMetaUtilFuncs=pMetaUtilFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Attach(PLUG_LOADTIME now, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals, gamedll_funcs_t *pGamedllFuncs) {
	gpMetaGlobals=pMGlobals;
	memcpy(pFunctionTable, &gMetaFunctionTable, sizeof(META_FUNCTIONS));
	gpGamedllFuncs=pGamedllFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Detach(PLUG_LOADTIME now, PL_UNLOAD_REASON reason) {
	return(TRUE);
}

void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals ) 
{
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;

	CVAR_REGISTER(&nsa_max_idletime);
	CVAR_REGISTER(&nsa_max_rrcamptime);
	CVAR_REGISTER(&nsa_check_angles);
	CVAR_REGISTER(&nsa_disable_notice);
}

DLL_FUNCTIONS gFunctionTable;
C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) 
{
	gFunctionTable.pfnSpawn = DispatchSpawn;
	gFunctionTable.pfnClientConnect = ClientConnect;
	gFunctionTable.pfnClientPutInServer = ClientPutInServer;
	gFunctionTable.pfnClientDisconnect = ClientDisconnect;
	gFunctionTable.pfnPlayerPreThink = PlayerPreThink;
	gFunctionTable.pfnPlayerPostThink = PlayerPostThink;

	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

