#include "extdll.h"
#include "dllapi.h"
#include "meta_api.h"
#include "cbase.h"
#include "plugin.h"

void UTIL_LogPrintf( char *fmt, ... )
{
   va_list      argptr;
   static char  string[1024];
   
   va_start ( argptr, fmt );
   vsprintf ( string, fmt, argptr );
   va_end   ( argptr );

   // Print to server console
   ALERT( at_logged, "%s", string );
}
/*
void UTIL_WriteToFile(const char *file, const char *pText)
{
	FILE *fp;
	fp = fopen(file, "a");
	if(fp)
	{
		fprintf(fp, "%s", pText);
		fclose(fp);
	}
}
*/
char* UTIL_VarArgs( char *format, ... )
{
        va_list         argptr;
        static char             string[1024];
        
        va_start (argptr, format);
        vsprintf (string, format,argptr);
        va_end (argptr);

        return string;  
}
/*
CBaseEntity *UTIL_FindEntityByClassname( CBaseEntity *pStartEntity, const char *szName )
{
	return UTIL_FindEntityByString( pStartEntity, "classname", szName );
}

CBaseEntity *UTIL_FindEntityByTargetname( CBaseEntity *pStartEntity, const char *szName )
{
	return UTIL_FindEntityByString( pStartEntity, "targetname", szName );
}

CBaseEntity *UTIL_FindEntityByString( CBaseEntity *pStartEntity, const char *szKeyword, const char *szValue )
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_BY_STRING( pentEntity, szKeyword, szValue );

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}
*/
int GetPlayerClass(edict_t *pEntity)
{
	if(pEntity->v.team)//Make sure they are on a team.
	{
		char *infobuffer;
		char model[32];
		
		infobuffer = (*g_engfuncs.pfnGetInfoKeyBuffer)(pEntity);
		strcpy(model, (g_engfuncs.pfnInfoKeyValue(infobuffer, "model")));
		
		if(!strcmp(model,	   "alien1"))return 1;
		else if(!strcmp(model, "alien2"))return 2;
		else if(!strcmp(model, "alien3"))return 3;
		else if(!strcmp(model, "alien4"))return 4;
		else if(!strcmp(model, "alien5"))return 5;
		else if(!strcmp(model, "gestate"))return 6;
		else if(!strcmp(model, "soldier") && pEntity->v.body == 0)return 7;//Normal
		else if(!strcmp(model, "soldier") && pEntity->v.body == 1)return 8;//Jetpack
		else if(!strcmp(model, "heavy"))return 9;
		else if(!strcmp(model, "commander"))return 10;
	}
	return 0;
}
/*
int GetPlayerSpecies(edict_t *pEntity)
{
	if(pEntity->v.team)//Make sure they are on a team.
	{
		char *infobuffer;
		char model[32];
		
		infobuffer = (*g_engfuncs.pfnGetInfoKeyBuffer)(pEntity);
		strcpy(model, (g_engfuncs.pfnInfoKeyValue(infobuffer, "model")));
		
		if(!strcmp(model,	   "alien1"))return 2;
		else if(!strcmp(model, "alien2"))return 2;
		else if(!strcmp(model, "alien3"))return 2;
		else if(!strcmp(model, "alien4"))return 2;
		else if(!strcmp(model, "alien5"))return 2;
		else if(!strcmp(model, "gestate"))return 2;
		else if(!strcmp(model, "soldier"))return 1;
		else if(!strcmp(model, "heavy"))return 1;
		else if(!strcmp(model, "commander"))return 1;
	}
	return 0;
}

int NSASendToSpawn(edict_t *pEntity)
{
	if(GetPlayerSpecies(pEntity) == 1)
	{
		CBaseEntity *pCEnt = NULL;
		while(pCEnt = UTIL_FindEntityByClassname(pCEnt, "team_infportal"))
		{
			CBaseEntity *pCommand = NULL;
			while(pCommand = UTIL_FindEntityByClassname(pCommand, "team_command"))
			{	
				if(pCEnt->pev->team == pEntity->v.team && IsBuilt(pCEnt->edict()))
				{
					pEntity->v.origin.x = pCEnt->pev->origin.x;
					pEntity->v.origin.y = pCEnt->pev->origin.y;
					pEntity->v.origin.z = pCEnt->pev->origin.z + 100;
					pEntity->v.velocity = Vector(RANDOM_LONG(-750,750), RANDOM_LONG(-750,750), RANDOM_LONG(-750,750));
					return 1;
				}
			}
		}
	}
	else if(GetPlayerSpecies(pEntity) == 2)
	{	
		CBaseEntity *pCEnt = NULL;
		while(pCEnt = UTIL_FindEntityByClassname(pCEnt, "info_team_start"))
		{
			CBaseEntity *pHive = NULL;
			while(pHive = UTIL_FindEntityByClassname(pHive, "team_hive"))
			{	
				if((pHive->pev->origin - pCEnt->pev->origin).LengthSquared() < (1024*1024) && IsBuilt(pHive->edict()))
				{
					if(pCEnt->pev->team == pEntity->v.team)
					{
						if(pCEnt->pev->fuser1 < gpGlobals->time)
						{
							pEntity->v.origin = pCEnt->pev->origin;
							pEntity->v.velocity = Vector(RANDOM_LONG(-750,750), RANDOM_LONG(-750,750), RANDOM_LONG(-750,750));
							PlayerInfo[ENTINDEX(pEntity)].IsClipped = gpGlobals->time + 0.5;
							pCEnt->pev->fuser1 = gpGlobals->time + 10.0;
							return 1;
						}
					}
				}
				
			}
		}
	}
	return 0;
}


bool IsBuilt(edict_t *pent)
{
	if( ! (pent->v.iuser4 & (1<<2)) )
	{
		return true;
	}
	else if(FStrEq(STRING(pent->v.classname),"team_hive") && pent->v.fuser1 >= 1000)//Hives are just wierd.
	{
		pent->v.iuser4 &= ~(1<<2);
		return true;
	}
	return false;

}
void UTIL_ShowMenu( edict_t *pEdict, int slots, int displaytime, bool needmore, char *pText )
{
	
	MESSAGE_BEGIN( MSG_ONE, REG_USER_MSG( "ShowMenu", -1 ), NULL, pEdict );
	
	WRITE_SHORT( slots );
	WRITE_CHAR( displaytime );
	WRITE_BYTE( needmore );
	WRITE_STRING( pText );
	
	MESSAGE_END();
}
*/
void NSASayAll(char *pText, int msg_type)
{
	if( CVAR_GET_FLOAT("nsa_disable_notice") > 0 )
		return;

	for (int i = 1; i <= gpGlobals->maxClients; i++ )
	{
		edict_t *pPlayer = g_engfuncs.pfnPEntityOfEntIndex( i );
		if (UTIL_IsValidEntity(pPlayer) && !FStrEq(STRING(pPlayer->v.netname),"") && FStrEq(STRING(pPlayer->v.classname),"player"))
		{
			ClientPrint2(pPlayer, msg_type, pText);
		}
	}
}

void ClientPrint2( edict_t *pEntity, int msg_dest, const char *msg_name)
{
   MESSAGE_BEGIN( MSG_ONE, REG_USER_MSG( "TextMsg", -1 ), NULL, pEntity );
   WRITE_BYTE( msg_dest );
   WRITE_STRING( msg_name );
   MESSAGE_END();
}

BOOL UTIL_IsValidEntity( edict_t *pent )
{
	if ( !pent || pent->free || (pent->v.flags & FL_KILLME) )
		return FALSE;
	return TRUE;
}

bool IsAdmin(edict_t *pEntity)//Thanks [WHO]Them.
{
	cvar_t *serverops = CVAR_GET_POINTER("mp_serverops");
	unsigned int counter = 0;
	char outbuffer[200] = "";
	unsigned int outbuffer_position = 0;
	
	while(true)
	{
		if( serverops->string[counter] == ' ' ) 
		{
			++counter;
			continue;
		}
		if( serverops->string[counter] == ';' || serverops->string[counter] == '\0') 
		{

			outbuffer[outbuffer_position] = '\0';
			if(FStrEq(outbuffer, GETPLAYERAUTHID(pEntity))) 
			{
				outbuffer[0] = '\0';
				return true;
			}
			outbuffer[0] = '\0';
			outbuffer_position = 0;
		}
		else 
		{
			outbuffer[outbuffer_position] = serverops->string[counter];
			++outbuffer_position;
		}
		++counter;
		if(serverops->string[counter-1] == '\0') 
		{
			return false;
		}
	}
	return false;
}
/*
int KillEntity(edict_t *pEntity)
{
	int istr = MAKE_STRING("trigger_hurt");	
	edict_t *pEntKiller = CREATE_NAMED_ENTITY(istr);
	entvars_t *pevKiller = VARS(pEntKiller);
	pevKiller->origin = Vector(RANDOM_LONG(10,15)*1000, 10000, 10000);
	
	KeyValueData	kvd;
	char			buf[128];
	
	sprintf( buf, "9999999");
	kvd.fHandled = FALSE;
	kvd.szClassName = NULL;
	kvd.szKeyName = "dmg";
	kvd.szValue = buf;
	MDLL_Spawn( pEntKiller );
	MDLL_KeyValue(pEntKiller, &kvd);
	
	sprintf( buf, "256");
	kvd.fHandled = FALSE;
	kvd.szClassName = NULL;
	kvd.szKeyName = "damagetype";
	kvd.szValue = buf;
	MDLL_KeyValue(pEntKiller, &kvd);
	pevKiller->classname = MAKE_STRING("nsa_kill");
	pevKiller->nextthink = gpGlobals->time;	
	MDLL_Touch(pEntKiller, pEntity);
	pevKiller->flags = FL_KILLME;
	return 0;
}*/